#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int int64_t

struct DSU {
    vector<int> p, next;
    explicit DSU(int n) : p(n + 1), next(n + 1) {
        iota(p.begin(), p.end(), 0);
        iota(next.begin(), next.end(), 1);
    }
    int get(int u) {
        return p[u] == u ? u : p[u] = get(p[u]);
    }

    void unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        p[u] = v;
        next[u] = max(next[u], next[v]);
    }

    int getnext(int u) {
        u = get(u);
        return next[u];
    }
};

struct segmentTree {
    vector<int> tree, a;
    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = (a[l] == 0);
            return;
        }
        int m = l + r >> 1;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    int spusk(int v, int l, int r, int x) {
        if (tree[v] < x) return -1;
        if (r - l == 1 && tree[v] == x) {
            return l;
        }
        int m = l + r >> 1;
        if (tree[2 * v + 1] >= x) return spusk(2 * v + 1, l, m, x);
        else return spusk(2 * v + 2, m, r, x - tree[2 * v + 1]);
    }

    void upd(int v, int l, int r, int q, int x) {
        if (r - l == 1 && l == q) {
            tree[v] = (x == 0);
            return;
        }
        int m = l + r >> 1;
        if (m > q) upd(2 * v + 1, l, m, q, x);
        else upd(2 * v + 2, m, r, q, x);
        tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    }

    explicit segmentTree(vector<int>& v) {
        int n = v.size();
        a = v;
        tree.resize(4 * n);
        build(0, 0, n);
    }
};

struct sgtt {
    vector<int> tree, a;
    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = a[l];
            return;
        }
        int m = l + r >> 1;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return tree[v];
        if (l >= qr || ql >= r) return 0;
        int m = l + r >> 1;
        return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }
    explicit sgtt(vector<int>& v) {
        int n = v.size();
        a = v;
        tree.resize(4 * n);
        build(0, 0, n);
    }
};

void solve() {
    int n; cin >> n;
    vector<int> h(n);
    for (auto& x : h) cin >> x;
    DSU dsu(n);
    vector<int> p(n, 0);
    segmentTree sgt(p);
    sgtt sgt2(h);
    for (int iiii = 1; iiii < n; ++iiii) {
        int i; cin >> i;
        i--;
        int j = sgt.spusk(0, 0, n, i + 1);
        int nj = dsu.getnext(j);
        sgt.upd(0, 0, n, nj, 1);
        int sum = 0;
        int k = dsu.getnext(nj);
        for (int ii = j; ii < k; ++ii) {
            int lp = sgt2.get(0, 0, n, j, ii + 1);
            int rp = sgt2.get(0, 0, n, ii, k);
            sum += min(rp, lp) - h[ii];
        }
        dsu.unite(j, nj);
        cout << sum << '\n';
    }
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}