#include <bits/stdc++.h>
using namespace std;

// #pragma GCC target("avx2")
// #pragma GCC optimize("O3, unroll-loops")

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define int int64_t

struct segmentTree {
    struct node {
        int sum, max, cnt0;
        int pending;
    };
    node merge(node x, node y) {
        node res;
        res.sum = x.sum + y.sum;
        res.cnt0 = x.cnt0 + y.cnt0;
        res.max = max(x.max, y.max);
        res.pending = -1e18;
        return res;
    }
    vector<node> tree;
    vector<int> a;
    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v].cnt0 = (a[l] == 0);
            tree[v].max = a[l];
            tree[v].sum = a[l];
            return;
        }
        int m = l + r >> 1;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void apply(int v, int l, int r, int x) {
        tree[v].pending = x;
        tree[v].max = x;
        tree[v].cnt0 = (x == 0 ? r - l : 0);
        tree[v].sum = (r - l) * x;
    }

    void push(int v, int l, int r) {
        if (tree[v].pending == -1e18) {
            return;
        }
        int m = l + r >> 1;
        apply(2 * v + 1, l, m, tree[v].pending);
        apply(2 * v + 2, m, r, tree[v].pending);
        tree[v].pending = -1e18;
    }

    int spusk(int v, int l, int r, int x) {
        if (tree[v].cnt0 < x) return -1;
        if (r - l == 1 && tree[v].cnt0 == x) {
            return l;
        }
        if (r - l == 1) return -1;
        int m = l + r >> 1;
        push(v, l, r);
        if (tree[2 * v + 1].cnt0 >= x) return spusk(2 * v + 1, l, m, x);
        else return spusk(2 * v + 2, m, r, x - tree[2 * v + 1].cnt0);
    }

    node get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return tree[v];
        if (l >= qr || ql >= r) return {0, 0, 0};
        int m = l + r >> 1;
        push(v, l, r);
        return merge(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    void upd(int v, int l, int r, int ql, int qr, int x) {
        if (l >= ql && r <= qr) {
            apply(v, l, r, x);
            return;
        }
        if (l >= qr || ql >= r) return;
        int m = l + r >> 1;
        push(v, l, r);
        upd(2 * v + 1, l, m, ql, qr, x);
        upd(2 * v + 2, m, r, ql, qr, x);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void upd(int v, int l, int r, int q, int x) {
        if (r - l == 1 && l == q) {
            tree[v].cnt0 = (x == 0);
            tree[v].max = tree[v].sum = x;
            return;
        }
        int m = l + r >> 1;
        push(v, l, r);
        if (m > q) upd(2 * v + 1, l, m, q, x);
        else upd(2 * v + 2, m, r, q, x);
        tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
    }

    // explicit segmentTree(vector<int>& v) {
    //     int n = v.size();
    //     a = v;
    //     tree.resize(4 * n);
    //     build(0, 0, n);
    // }
};

segmentTree sgt, sgt2, sgt3;
int id;

struct DSU {
    vector<int> p, next, ans, lmn, rmn, mx;
    int n;
    vector<int> vv;
    explicit DSU(int _n, vector<int>& a) : vv(a), p(_n + 1), next(_n + 1), ans(_n, 0), lmn(_n), rmn(_n), mx(_n) {
        n = _n;
        iota(p.begin(), p.end(), 0);
        iota(lmn.begin(), lmn.end(), 0);
        iota(rmn.begin(), rmn.end(), 0);
        iota(next.begin(), next.end(), 1);
        for (int i = 0; i < _n; ++i) mx[i] = a[i];
    }
    int get(int u) {
        return p[u] == u ? u : p[u] = get(p[u]);
    }

    void unite(int u, int v, vector<int>& d) {
        u = get(u), v = get(v);
        if (u == v) return;
        p[u] = v;
        next[u] = max(next[u], next[v]);

        if (n > 1000) {

            lmn[v] = lmn[u], rmn[u] = rmn[v];
            int x = min(vv[lmn[v]], vv[rmn[v]]);
            sgt3.upd(0, 0, n, lmn[v], rmn[v] + 1, x);
            return;
        }

        int l = lmn[u] - 1, r = rmn[u] + 1;
        while (r - l > 1) {
            int m = l + r >> 1;
            if (sgt2.get(0, 0, n, lmn[u], m + 1).max > mx[v]) r = m;
            else l = m;
        }
        int i1 = r;
        l = lmn[u] - 1, r = rmn[u] + 1;
        while (r - l > 1) {
            int m = l + r >> 1;
            if (sgt2.get(0, 0, n, m, rmn[u] + 1).max < mx[v]) {
                r = m;
            } else l = m;
        }
        i1 = max(i1, r);
        if (i1 <= rmn[u]) {
            // for (int i = i1; i <= rmn[u]; ++i)
            //     d[i] = mx[v];
            sgt3.upd(0, 0, n, i1, rmn[u] + 1, mx[v]);
        }
        for (int i = lmn[u]; n <= 1000 && i <= min(i1 - 1, rmn[u]); ++i) {
            sgt3.upd(0, 0, n, i, i + 1, min({max(sgt2.get(0,0,n,i,rmn[u]+1).max,mx[v]), sgt2.get(0,0,n,lmn[u],i+1).max}));
        }


        l = lmn[v] - 1, r = rmn[v] + 1;
        while (r - l > 1) {
            int m = l + r >> 1;
            if (sgt2.get(0, 0, n, m, rmn[v] + 1).max > mx[u]) {
                l = m;
            } else r = m;
        }
        i1 = l;
        l = lmn[v] - 1, r = rmn[v] + 1;
        while (r - l > 1) {
            int m = l + r >> 1;
            if (sgt2.get(0, 0, n, lmn[v], m + 1).max < mx[u]) {
                l = m;
            } else r = m;
        }
        i1 = min(i1, l);
        if (i1 >= lmn[v]) {
            sgt3.upd(0, 0, n, lmn[v], i1 + 1, mx[u]);
        }
        if (n <= 1000) {
            for (int i = max(i1 + 1, lmn[v]); i <= rmn[v]; ++i) {
                sgt3.upd(0, 0, n, i, i + 1, min({max(mx[u], sgt2.get(0,0,n,lmn[v],i+1).max),sgt2.get(0,0,n,i,rmn[v]+1).max}));
            }
        }

        lmn[v] = lmn[u], rmn[u] = rmn[v];
        mx[v] = max(mx[u], mx[v]);
    }

    int getnext(int u) {
        u = get(u);
        return next[u];
    }
};

void solve() {
    int n; cin >> n;
    vector<int> h(n);
    for (auto& x : h) cin >> x;
    for (int i = 0; i < n - 1; ++i) {
        if (h[i] < h[i + 1]) {
            id = i;
            break;
        }
    }
    DSU dsu(n, h);
    vector<int> p(n, 0);
    vector<int> d(n, 0);
    for (int i = 0; i < n; ++i) d[i] = h[i];
    sgt.tree.resize(4 * n), sgt2.tree.resize(4 * n), sgt3.tree.resize(4 * n);
    sgt.a = p, sgt2.a = h, sgt3.a = d;
    sgt.build(0, 0, n), sgt2.build(0, 0, n), sgt3.build(0, 0, n);
    for (int iiii = 1; iiii < n; ++iiii) {
        int i; cin >> i;
        i--;
        int j = sgt.spusk(0, 0, n, i + 1);
        int nj = dsu.getnext(j);
        sgt.upd(0, 0, n, nj, 1);
        int k = dsu.getnext(nj);
        dsu.unite(j, nj, d);
        int s = 0;
        for (int ii = j; ii < k; ++ii)
            s += d[ii];
        cout << -sgt2.get(0, 0, n, j, k).sum + sgt3.get(0, 0, n, j, k).sum << endl;
    }
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}