#include <bits/stdc++.h>

#define int int64_t

using namespace std;

struct sgt {
    vector<int> t;
    void build(int v, int l, int r, const vector<int>& a) {
        if (r - l == 1) {
            t[v] = a[l];
            return;
        }
        int m = l + r >> 1;
        build(2 * v + 1, l, m, a);
        build(2 * v + 2, m, r, a);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
    int get(int v, int l, int r, int ql, int qr) {
        if (l >= ql && r <= qr) return t[v];
        if (l >= qr || ql >= r) return 1e18;
        int m = l + r >> 1;
        return min(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
    }

    explicit sgt(const vector<int>& a) {
        int n = a.size();
        t.resize(4 * n);
        build(0, 0, a.size(), a);
    }
};

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (auto& x : a) cin >> x;
    vector<int> prefmn(n, a[0]), suffmn(n, a[n-1]);
    for (int i = 1; i < n; ++i) {
        prefmn[i] = max(prefmn[i - 1], a[i]);
    }
    for (int i = n - 2; i >= 0; --i) {
        suffmn[i] = max(suffmn[i + 1], a[i]);
    }
    vector<int> p(n + 1, 0);
    partial_sum(a.begin(), a.end(), 1 + p.begin());
    if (k == 2) {
        int l = 0, r = n - k;
        int mx = 0;
        while (r < n) {
            int mn = p[r + 1] - p[l];
            if (l > 0) mn = min(mn, prefmn[l - 1]);
            if (r < n - 1) mn = min(mn, suffmn[r + 1]);
            mx = max(mx, p[r + 1] - p[l] - mn);
            l++;
            r++;
        }
        cout << mx;
        return;
    }
    if (k == 3) {
        assert(n < 10);
        int mx = 0;
        for (int i = 1; i < n - 1; ++i) {
            mx = max(mx, max(p[i], p[n] - p[i + 1]) - a[i]);
        }
        mx = max(mx, p[n - 1] - p[1] - min(a[0], a[n - 1]));
        cout << mx;
        return;
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}